package tanasys.action.resource.regist;

import java.sql.Date;
import java.sql.SQLException;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;

import tanasys.BaseAction;
import tanasys.dao.ResourceDAO;
import tanasys.dao.StaffDAO;

public class ResourceRegistAction extends BaseAction {

  @Override
  protected ActionForward act(ActionMapping mapping, ActionForm actionForm,
      HttpServletRequest request, HttpServletResponse response)
      throws Exception {
    ResourceRegistForm resourceRegistForm = (ResourceRegistForm) actionForm;
    ResourceDAO resourceDao = new ResourceDAO();
    StaffDAO staffDao = new StaffDAO();
    ActionMessages errors = new ActionMessages();

    try {
      resourceRegistForm.setMessage("");
      // ͘RꂪȂ`FbN
      if (resourceRegistForm.getResourceAfter().getUser().equals("")
          || resourceRegistForm.getResourceAfter().getAdmin().equals("")
          || resourceRegistForm.getResourceAfter().getPlace().equals("")) {
        resourceRegistForm.setMessage("̓~X");
        errors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage(
            "errors.input"));
        saveErrors(request, errors);

        return mapping.findForward("error");
      }

      System.out.println("afterName="
          + resourceRegistForm.getResourceAfter().getUser());
      System.out.println("beforeName="
          + resourceRegistForm.getResourceBefore().getUser());

      // ȉύX`FbN
      if (resourceRegistForm.getResourceAfter().getUser().equals(
          resourceRegistForm.getResourceBefore().getUser())
          && resourceRegistForm.getResourceAfter().getAdmin().equals(
              resourceRegistForm.getResourceBefore().getAdmin())
          && resourceRegistForm.getResourceAfter().getPlace().equals(
              resourceRegistForm.getResourceBefore().getPlace())
          && resourceRegistForm.getResourceAfter().getUseStatusCode().equals(
              resourceRegistForm.getResourceBefore().getUseStatusCode())
          && resourceRegistForm.getResourceAfter().getDeptId().equals(
              resourceRegistForm.getResourceBefore().getDeptId())) {
        resourceRegistForm.setMessage("ύXĂ܂");
        errors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage(
            "errors.notChanged"));
        saveErrors(request, errors);

        return mapping.findForward("error");
      }

      // iړ\Of[^x[Xɑ}
      int result = resourceDao.insertResourceBeforeUpdate(resourceRegistForm
          .getResourceBefore());
      if (result < 1) {
        resourceRegistForm.setMessage("SQLG[");
        errors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage(
            "errors.login"));
        saveErrors(request, errors);

        return mapping.findForward("error");
      }

      // ͂ꂽOID擾
      String userId = staffDao.getIdByName(resourceRegistForm
          .getResourceAfter().getUser());
      String adminId = staffDao.getIdByName(resourceRegistForm
          .getResourceAfter().getAdmin());

      if (userId == null || adminId == null) {
        errors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage(
            "errors.inputMistake"));
        saveErrors(request, errors);
        return mapping.findForward("error");
      }

      // 擾IDZbg
      resourceRegistForm.getResourceAfter().setUserId(userId);
      resourceRegistForm.getResourceAfter().setAdminId(adminId);
      // ٓ\̓ɂZbg
      Date date = new Date(System.currentTimeMillis());
      resourceRegistForm.getResourceAfter().setUpdateDate(date.toString());
      // ٓ\lIDZbg
      HttpSession session = request.getSession(false);
      String id = (String) session.getAttribute("ID");
      resourceRegistForm.getResourceAfter().setUpdateId(id);

      // iٓ\f[^x[Xɑ}
      resourceDao.registResource(resourceRegistForm.getResourceAfter());

      resourceRegistForm.setMessage("ٓ\ł܂");
      return mapping.findForward("success");

    } catch (SQLException e) {
      resourceRegistForm.setMessage("SQLG[");
      errors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage(
          "errors.login"));
      saveErrors(request, errors);

      return mapping.findForward("error");
    }
  }

}
