CREATE TABLE USE_STATUS (
  STATUS_ID CHAR(2) NOT NULL,
  STATUS_NAME VARCHAR(10) NULL,
  REG_ID CHAR(5) NULL,
  REG_DATE DATE NULL,
  PRIMARY KEY(STATUS_ID)
);

CREATE TABLE M_STAFF   (
  EMP_ID CHAR(5) NOT NULL,
  EMP_NAME VARCHAR(20) NULL,
  EMP_DEPT_ID CHAR(3) NULL,
  EMP_PASSWORD CHAR(16) NULL,
  REG_ID CHAR(5) NULL,
  REG_DATE DATE NULL,
  RETIRE_DATE CHAR(8) NULL,
  PRIMARY KEY(EMP_ID)
);

CREATE TABLE M_DEPARTMENT   (
  DEPT_ID CHAR(3) NOT NULL,
  DEPT_NAME VARCHAR(30) NULL,
  REG_ID CHAR(5) NULL,
  REG_DATE DATE NULL,
  PRIMARY KEY(DEPT_ID)
);

CREATE TABLE RESOURCE (
  RES_NO CHAR(15) NOT NULL,
  RES_CHECK_NO VARCHAR(15) NULL,
  RES_NAME VARCHAR(100) NULL,
  RES_MAKER VARCHAR(40) NULL,
  RES_MODEL_NO VARCHAR(40) NULL,
  RES_SERIAL_NO VARCHAR(40) NULL,
  RES_PARENT CHAR(15) NULL,
  RES_USER CHAR(5) NOT NULL,
  RES_ADMIN CHAR(5) NOT NULL,
  RES_DEPT CHAR(3) NOT NULL,
  RES_STATUS_USE CHAR(2) NOT NULL,
  RES_PLACE VARCHAR(50) NULL,
  RES_MOVE_DATE DATE NULL,
  RES_NOTE VARCHAR(100) NULL,
  RES_STATUS_STOCK TINYINT NULL,
  RES_COMMIT_ID CHAR(5) NULL,
  RES_COMMIT_DATE DATE NULL,
  REG_ID CHAR(5) NULL,
  REG_DATE DATE NULL,
  UPD_ID CHAR(5) NULL,
  UPD_DATE DATE NULL,
  PRIMARY KEY(RES_NO),
  INDEX RES_FKIndex2(RES_DEPT),
  INDEX RES_FKIndex3(RES_STATUS_USE),
  INDEX RES_FKIndex5(RES_USER),
  INDEX RES_FKIndex4(RES_ADMIN),
  FOREIGN KEY(RES_DEPT)
    REFERENCES M_DEPARTMENT  (DEPT_ID)
      ON DELETE NO ACTION
      ON UPDATE NO ACTION,
  FOREIGN KEY(RES_STATUS_USE)
    REFERENCES USE_STATUS(STATUS_ID)
      ON DELETE NO ACTION
      ON UPDATE NO ACTION,
  FOREIGN KEY(RES_USER)
    REFERENCES M_STAFF  (EMP_ID)
      ON DELETE NO ACTION
      ON UPDATE NO ACTION,
  FOREIGN KEY(RES_ADMIN)
    REFERENCES M_STAFF  (EMP_ID)
      ON DELETE NO ACTION
      ON UPDATE NO ACTION
);

CREATE TABLE RESOURCE_BEFORE_UPDATE (
  RES_NO CHAR(15) NOT NULL,
  RES_USER CHAR(5) NULL,
  RES_ADMIN CHAR(5) NULL,
  RES_DEPT CHAR(3) NULL,
  RES_PLACE VARCHAR(50) NULL,
  RES_STATUS CHAR(2) NULL,
  REG_ID CHAR(5) NULL,
  REG_DATE DATE NULL,
  PRIMARY KEY(RES_NO),
  INDEX RESOURCE_BEFORE_UPDATE_FKIndex1(RES_NO),
  FOREIGN KEY(RES_NO)
    REFERENCES RESOURCE(RES_NO)
      ON DELETE NO ACTION
      ON UPDATE NO ACTION
);

